.TH PSIGL l "19 April 1989"
.SH NAME
psigl \- IGL filter for PostScript monochrome 300 DP printer.
.SH SYNOPSIS
.B "psigl standard-par-options special-par-options"
.SH DESCRIPTION
.I psigl
is a filter for the
.I Intermediate Graphics Language
(IGL) to produce graphics on a 300 DP PostScript printer.
As with all IGL filters,
.I psigl
reads graphics commands off standard
input (from a pipe or file).  It will send its output to stdout.
In most circumstances, you will want to pipe the output to the
.I lpr
command.
.SH STANDARD-PARS
The standard pars for
.I psigl
are the same as those for other IGL
filters.  Some of the useful standard pars are:
.IP pagerot=angle
will rotate the plot counterclockwise with respect to the page.
The angles are rounded to multiples of 90 degrees.
If you want a plot with a longer Y axis, you should rotate the plot by 270
(or -90).
.IP xorig=inches
.br
sets the origin for the plot at the requested position (in inches)
from the left edge of the page.
.IP yorig=inches
.br
Same as xorig, for vertical position measured up from the bottom of
the page.

.SH SPECIAL-PARS
These parameters are unique to the
.I psigl
filter.
.IP devxoff=f
This options specifies the amount that the image should be translated in the
X direction.  The amount is specified in inches.
.IP devyoff=f
This options specifies the amount that the image should be translated in the
Y direction.  The amount is specified in inches.
.IP devrot=f
This options specifies the rotation in degrees of the image on the paper.
.IP devscale=f
This options specifies a scaling factor for the entire image.

.SH EXAMPLES
The following example shows psigl reading an intermediate IGL file
and sending the PostScript output to the "lw" laserprinter by using the lpr
command.
.br
    psigl < myplot.igl | lpr -Plw
.br
.sp
The following example shows a program generating IGL output that is piped
directly to psigl.  The Postscript output from psigl is sent directly to the
"lw" laser printer.
.br
    myprog | psigl | lpr -Plw
.br
.SH BUGS
The patterns appear to be aligned specifically to work well with specific
PostScript printers, and produce registration on others.

Although PostScript is supposed to be device independent, psigl assumes that
it is generating output for a 300 DPI printer.

.SH NOTES
IGL is copyrighted by Robert W. Clayton, all rights reserved.

.SH AUTHOR
.I psigl
was written by ?? Kanamori and was modified by Doug Neuhauser.
