.TH ZETA l "19 April 1989"
.SH NAME
zeta \- IGL filter for Zeta pen plotter
.SH SYNOPSIS
.B "zeta standard-par-options special-par-options"
.SH DESCRIPTION
.I zeta
is a filter for the
.I Intermediate Graphics Language
(IGL) to produce graphics on a Zeta pen plotter.
As with all IGL filters,
.I zeta
reads graphics commands off standard
input (from a pipe or file).  It will send its output directly to the
zeta spooler.  The default page orientation provides a page with 8.5" in the
X direction and 11" in the Y direction, with a maximum of 144 feet in the X
direction. 
.SH STANDARD-PARS
The standard pars for
.I zeta
are the same as those for other IGL
filters.  Some of the useful standard pars are:
.IP pagerot=angle
will rotate the plot counterclockwise with respect to the page.
The angles are rounded to multiples of 90 degrees.
If you want a plot with a longer Y axis, you should rotate the plot by 270
(or -90).
.IP xorig=inches
.br
sets the origin for the plot at the requested position (in inches)
from the left edge of the page.
.IP yorig=inches
.br
Same as xorig, for vertical position measured up from the bottom of
the page.

.SH SPECIAL-PARS
These parameters are unique to the
.I zeta
filter.
.IP pen=n
This option specifies that color 0 (the default color) should correspond to the
n-th pen in the pen carousel.  This effectively swaps the first and n-th pen.
.IP speed=n
This option set the pen speed on the plotter.  You may specify a speed
between 1 and 20 inclusive.  If no speed is specified, the plotter
will default to its maximum speed.
.IP dfat (boolean)
This boolean option instructs
.I zeta
to attempt to draw fat lines
with multiple adjacent penstrokes.  Note that this option may
significantly increase the plotting time and pen wear.
.IP nolpr (boolean)
This boolean option prevents the output from being directed to the print
spooler, and will output the pen plotter commands to stdout instead.  This
option is primarily useful for debugging.

.SH BUGS
The color mappings defined by defcolor are ignored, since you cannot
produce arbitrary colors on the pen plotter.

The IGL pens 0 - 255 are mapped to the 8 pens in the zeta plotter by
the formual:
.br
    zeta_pen = (IGL_pen modulo 8) + 1
.br

The only character font generated by
.I zeta
is the plain font,
since the fancy fonts (as currently defined) are plotted too slowly by the
pen plotter.

.SH NOTES
IGL is copyrighted by Robert W. Clayton, all rights reserved.

.SH AUTHOR
.I zeta
was written by Doug Neuhauser, based on several existing
IGL filters for other devices.
